#ifndef COMMON_H
#define COMMON_H

//Define limits
//For look ahead of 16 - shared memory = (len*5 + lookahead*5)*4
//Max query length is 2432. 
//#define MAXQLEN 2432+2
#define MAXQLEN 2440
#define FILENAME_LIMIT 1000
#define MAX_CONTIGS 50
#define BUFFERLEN 10000

#define AA 23
#define BASES 5

//Max number of possible letters
#define LETTERS 26

//Set defaults
#define DEFAULT_GAPOPEN -26
#define DEFAULT_QNAME 1000
//Name of each genome or contig in genome FASTA file
#define DEFAULT_FNAME 1000
//Number of threads per SM
#define DEFAULT_THREADS 256

char* rev(char* str);
  
int DNAGenome ( int argc, char* argv[] );
int DBSearch ( int argc, char* argv[] );

#define OUTPUTTIME 0
#define DEBUG 0
#define NEG_INF -1000000
#define LOOK_AHEAD 16
#define ADDITIONAL_FRAGS 200
#define PSS_OFFSET LOOK_AHEAD*BASES

#endif

