#include "Common.h"

//Device globals
//__constant__ int dev_subst_index_constant[LETTERS];
//__constant__ float dev_pos_specific_scores_constant[MAXQLEN * BASES + BASES + PSS_OFFSET];

//__global__ void maxssmap_shared(unsigned int jobs_todo, char* database, float* results, unsigned int PSS_OFFSET) {
///uint4
__global__ void maxssmap_shared_uint4(unsigned int jobs_todo, uint4* database4, float* results, int dev_QLEN, int dev_FRAGMENTSIZE, int* dev_subst_index_constant, float* dev_pos_specific_scores_constant) {
//__global__ void maxssmap_shared_uint4(unsigned int jobs_todo, uint4* database4, float* results) {

  unsigned int id = threadIdx.x + blockIdx.x * blockDim.x;

  if(id < jobs_todo) {
    int j_, j, i, stop, k;
    unsigned int p;
    float score[16], max=0;
    char ch;
    char* ch_;
    uint4 i4;

    extern __shared__ float dev_pos_specific_scores[];
    __shared__ int dev_subst_index[LETTERS];

    if(threadIdx.x == 0) { 
//      for(i = 0; i < BASES * MAXQLEN; i++){ dev_pos_specific_scores[i] = dev_pos_specific_scores_constant[i]; }
      for(i = 0; i < BASES*dev_QLEN + PSS_OFFSET; i++){ dev_pos_specific_scores[i] = dev_pos_specific_scores_constant[i]; }
//      for(i = 0; i < BASES*dev_QLEN ; i++){ dev_pos_specific_scores[i] = dev_pos_specific_scores_constant[i]; }
      for(i = 0; i < LETTERS; i++){ dev_subst_index[i] = dev_subst_index_constant[i]; }
    } 
    __syncthreads();

    stop = dev_QLEN/16; stop = stop*16;

    for(i = 0; i < dev_FRAGMENTSIZE/16; i += 1){

      p = (jobs_todo+ADDITIONAL_FRAGS)*i; 
      k = 0;
      score[0] = 0; score[1] = 0; score[2] = 0; score[3] = 0; 
      score[4] = 0; score[5] = 0; score[6] = 0; score[7] = 0; 
      score[8] = 0; score[9] = 0; score[10] = 0; score[11] = 0; 
      score[12] = 0; score[13] = 0; score[14] = 0; score[15] = 0; 
/*      score[16] = 0; score[17] = 0; score[18] = 0; score[19] = 0; 
      score[20] = 0; score[21] = 0; score[22] = 0; score[23] = 0;
      score[24] = 0; score[25] = 0; score[26] = 0; score[27] = 0; 
      score[28] = 0; score[29] = 0; score[30] = 0; score[31] = 0; */
      for(j_ = 0; j_ < stop; j_ += 1){

	if(j_/16 + i >= (k+1)*dev_FRAGMENTSIZE/16) { p = 0; k++; } 
	i4 = database4[p + id + k]; 
	p += (jobs_todo+ADDITIONAL_FRAGS); 

        ch_ = (char*)&i4.x;
        ch = ch_[0];
        j = dev_subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += dev_pos_specific_scores[j_*BASES + j];
        score[1] += dev_pos_specific_scores[(j_-1)*BASES + j];
        score[2] += dev_pos_specific_scores[(j_-2)*BASES + j];
        score[3] += dev_pos_specific_scores[(j_-3)*BASES + j];
        score[4] += dev_pos_specific_scores[(j_-4)*BASES + j];
        score[5] += dev_pos_specific_scores[(j_-5)*BASES + j];
        score[6] += dev_pos_specific_scores[(j_-6)*BASES + j];
        score[7] += dev_pos_specific_scores[(j_-7)*BASES + j];
        score[8] += dev_pos_specific_scores[(j_-8)*BASES + j];
        score[9] += dev_pos_specific_scores[(j_-9)*BASES + j];
        score[10] += dev_pos_specific_scores[(j_-10)*BASES + j];
        score[11] += dev_pos_specific_scores[(j_-11)*BASES + j];
        score[12] += dev_pos_specific_scores[(j_-12)*BASES + j];
        score[13] += dev_pos_specific_scores[(j_-13)*BASES + j];
        score[14] += dev_pos_specific_scores[(j_-14)*BASES + j];
        score[15] += dev_pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += dev_pos_specific_scores[(j_-16)*BASES + j];
        score[17] += dev_pos_specific_scores[(j_-17)*BASES + j];
        score[18] += dev_pos_specific_scores[(j_-18)*BASES + j];
        score[19] += dev_pos_specific_scores[(j_-19)*BASES + j]; 
        score[20] += dev_pos_specific_scores[(j_-20)*BASES + j];
        score[21] += dev_pos_specific_scores[(j_-21)*BASES + j];
        score[22] += dev_pos_specific_scores[(j_-22)*BASES + j];
        score[23] += dev_pos_specific_scores[(j_-23)*BASES + j];
        score[24] += dev_pos_specific_scores[(j_-24)*BASES + j];
        score[25] += dev_pos_specific_scores[(j_-25)*BASES + j];
        score[26] += dev_pos_specific_scores[(j_-26)*BASES + j];
        score[27] += dev_pos_specific_scores[(j_-27)*BASES + j];  
        score[28] += dev_pos_specific_scores[(j_-28)*BASES + j];
        score[29] += dev_pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += dev_pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += dev_pos_specific_scores[(j_-31)*BASES + j]; */
        j_++; 

        ch = ch_[1];
        j = dev_subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += dev_pos_specific_scores[(j_)*BASES + j];
        score[1] += dev_pos_specific_scores[(j_-1)*BASES + j];
        score[2] += dev_pos_specific_scores[(j_-2)*BASES + j]; 
        score[3] += dev_pos_specific_scores[(j_-3)*BASES + j]; 
        score[4] += dev_pos_specific_scores[(j_-4)*BASES + j]; 
        score[5] += dev_pos_specific_scores[(j_-5)*BASES + j]; 
        score[6] += dev_pos_specific_scores[(j_-6)*BASES + j]; 
        score[7] += dev_pos_specific_scores[(j_-7)*BASES + j]; 
        score[8] += dev_pos_specific_scores[(j_-8)*BASES + j]; 
        score[9] += dev_pos_specific_scores[(j_-9)*BASES + j]; 
        score[10] += dev_pos_specific_scores[(j_-10)*BASES + j];
        score[11] += dev_pos_specific_scores[(j_-11)*BASES + j];
        score[12] += dev_pos_specific_scores[(j_-12)*BASES + j];
        score[13] += dev_pos_specific_scores[(j_-13)*BASES + j];
        score[14] += dev_pos_specific_scores[(j_-14)*BASES + j];
        score[15] += dev_pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += dev_pos_specific_scores[(j_-16)*BASES + j];
        score[17] += dev_pos_specific_scores[(j_-17)*BASES + j];
        score[18] += dev_pos_specific_scores[(j_-18)*BASES + j];
        score[19] += dev_pos_specific_scores[(j_-19)*BASES + j];  
        score[20] += dev_pos_specific_scores[(j_-20)*BASES + j];
        score[21] += dev_pos_specific_scores[(j_-21)*BASES + j];
        score[22] += dev_pos_specific_scores[(j_-22)*BASES + j];
        score[23] += dev_pos_specific_scores[(j_-23)*BASES + j];
        score[24] += dev_pos_specific_scores[(j_-24)*BASES + j];
        score[25] += dev_pos_specific_scores[(j_-25)*BASES + j];
        score[26] += dev_pos_specific_scores[(j_-26)*BASES + j];
        score[27] += dev_pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += dev_pos_specific_scores[(j_-28)*BASES + j];
        score[29] += dev_pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += dev_pos_specific_scores[(j_-30)*BASES + j];
        score[31] += dev_pos_specific_scores[(j_-31)*BASES + j];  */
        j_++; 

        ch = ch_[2];
        j = dev_subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += dev_pos_specific_scores[(j_)*BASES + j];
        score[1] += dev_pos_specific_scores[(j_-1)*BASES + j];
        score[2] += dev_pos_specific_scores[(j_-2)*BASES + j];
        score[3] += dev_pos_specific_scores[(j_-3)*BASES + j]; 
        score[4] += dev_pos_specific_scores[(j_-4)*BASES + j]; 
        score[5] += dev_pos_specific_scores[(j_-5)*BASES + j]; 
        score[6] += dev_pos_specific_scores[(j_-6)*BASES + j]; 
        score[7] += dev_pos_specific_scores[(j_-7)*BASES + j]; 
        score[8] += dev_pos_specific_scores[(j_-8)*BASES + j]; 
        score[9] += dev_pos_specific_scores[(j_-9)*BASES + j]; 
        score[10] += dev_pos_specific_scores[(j_-10)*BASES + j];
        score[11] += dev_pos_specific_scores[(j_-11)*BASES + j];
        score[12] += dev_pos_specific_scores[(j_-12)*BASES + j];
        score[13] += dev_pos_specific_scores[(j_-13)*BASES + j];
        score[14] += dev_pos_specific_scores[(j_-14)*BASES + j];
        score[15] += dev_pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += dev_pos_specific_scores[(j_-16)*BASES + j];
        score[17] += dev_pos_specific_scores[(j_-17)*BASES + j];
        score[18] += dev_pos_specific_scores[(j_-18)*BASES + j];
        score[19] += dev_pos_specific_scores[(j_-19)*BASES + j];   
        score[20] += dev_pos_specific_scores[(j_-20)*BASES + j];
        score[21] += dev_pos_specific_scores[(j_-21)*BASES + j];
        score[22] += dev_pos_specific_scores[(j_-22)*BASES + j];
        score[23] += dev_pos_specific_scores[(j_-23)*BASES + j];
        score[24] += dev_pos_specific_scores[(j_-24)*BASES + j];
        score[25] += dev_pos_specific_scores[(j_-25)*BASES + j];
        score[26] += dev_pos_specific_scores[(j_-26)*BASES + j];
        score[27] += dev_pos_specific_scores[(j_-27)*BASES + j];  
        score[28] += dev_pos_specific_scores[(j_-28)*BASES + j];
        score[29] += dev_pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += dev_pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += dev_pos_specific_scores[(j_-31)*BASES + j]; */
        j_++; 

        ch = ch_[3];
        j = dev_subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += dev_pos_specific_scores[(j_)*BASES + j];
        score[1] += dev_pos_specific_scores[(j_-1)*BASES + j];
        score[2] += dev_pos_specific_scores[(j_-2)*BASES + j];
        score[3] += dev_pos_specific_scores[(j_-3)*BASES + j];
        score[4] += dev_pos_specific_scores[(j_-4)*BASES + j]; 
        score[5] += dev_pos_specific_scores[(j_-5)*BASES + j]; 
        score[6] += dev_pos_specific_scores[(j_-6)*BASES + j]; 
        score[7] += dev_pos_specific_scores[(j_-7)*BASES + j]; 
        score[8] += dev_pos_specific_scores[(j_-8)*BASES + j]; 
        score[9] += dev_pos_specific_scores[(j_-9)*BASES + j]; 
        score[10] += dev_pos_specific_scores[(j_-10)*BASES + j];
        score[11] += dev_pos_specific_scores[(j_-11)*BASES + j];
        score[12] += dev_pos_specific_scores[(j_-12)*BASES + j];
        score[13] += dev_pos_specific_scores[(j_-13)*BASES + j];
        score[14] += dev_pos_specific_scores[(j_-14)*BASES + j];
        score[15] += dev_pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += dev_pos_specific_scores[(j_-16)*BASES + j];
        score[17] += dev_pos_specific_scores[(j_-17)*BASES + j];
        score[18] += dev_pos_specific_scores[(j_-18)*BASES + j];
        score[19] += dev_pos_specific_scores[(j_-19)*BASES + j]; 
        score[20] += dev_pos_specific_scores[(j_-20)*BASES + j];
        score[21] += dev_pos_specific_scores[(j_-21)*BASES + j];
        score[22] += dev_pos_specific_scores[(j_-22)*BASES + j];
        score[23] += dev_pos_specific_scores[(j_-23)*BASES + j];
        score[24] += dev_pos_specific_scores[(j_-24)*BASES + j];
        score[25] += dev_pos_specific_scores[(j_-25)*BASES + j];
        score[26] += dev_pos_specific_scores[(j_-26)*BASES + j];
        score[27] += dev_pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += dev_pos_specific_scores[(j_-28)*BASES + j];
        score[29] += dev_pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += dev_pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += dev_pos_specific_scores[(j_-31)*BASES + j]; */
        j_++; 

        ch_ = (char*)&i4.y;
        ch = ch_[0];
        j = dev_subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += dev_pos_specific_scores[(j_)*BASES + j];
        score[1] += dev_pos_specific_scores[(j_-1)*BASES + j];
        score[2] += dev_pos_specific_scores[(j_-2)*BASES + j];
        score[3] += dev_pos_specific_scores[(j_-3)*BASES + j];
        score[4] += dev_pos_specific_scores[(j_-4)*BASES + j];
        score[5] += dev_pos_specific_scores[(j_-5)*BASES + j];
        score[6] += dev_pos_specific_scores[(j_-6)*BASES + j]; 
        score[7] += dev_pos_specific_scores[(j_-7)*BASES + j]; 
        score[8] += dev_pos_specific_scores[(j_-8)*BASES + j]; 
        score[9] += dev_pos_specific_scores[(j_-9)*BASES + j]; 
        score[10] += dev_pos_specific_scores[(j_-10)*BASES + j];
        score[11] += dev_pos_specific_scores[(j_-11)*BASES + j];
        score[12] += dev_pos_specific_scores[(j_-12)*BASES + j];
        score[13] += dev_pos_specific_scores[(j_-13)*BASES + j];
        score[14] += dev_pos_specific_scores[(j_-14)*BASES + j];
        score[15] += dev_pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += dev_pos_specific_scores[(j_-16)*BASES + j];
        score[17] += dev_pos_specific_scores[(j_-17)*BASES + j];
        score[18] += dev_pos_specific_scores[(j_-18)*BASES + j];
        score[19] += dev_pos_specific_scores[(j_-19)*BASES + j]; 
        score[20] += dev_pos_specific_scores[(j_-20)*BASES + j];
        score[21] += dev_pos_specific_scores[(j_-21)*BASES + j];
        score[22] += dev_pos_specific_scores[(j_-22)*BASES + j];
        score[23] += dev_pos_specific_scores[(j_-23)*BASES + j];
        score[24] += dev_pos_specific_scores[(j_-24)*BASES + j];
        score[25] += dev_pos_specific_scores[(j_-25)*BASES + j];
        score[26] += dev_pos_specific_scores[(j_-26)*BASES + j];
        score[27] += dev_pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += dev_pos_specific_scores[(j_-28)*BASES + j];
        score[29] += dev_pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += dev_pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += dev_pos_specific_scores[(j_-31)*BASES + j]; */
        j_++;

        ch = ch_[1];
        j = dev_subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += dev_pos_specific_scores[(j_)*BASES + j];
        score[1] += dev_pos_specific_scores[(j_-1)*BASES + j];
        score[2] += dev_pos_specific_scores[(j_-2)*BASES + j];
        score[3] += dev_pos_specific_scores[(j_-3)*BASES + j];
        score[4] += dev_pos_specific_scores[(j_-4)*BASES + j];
        score[5] += dev_pos_specific_scores[(j_-5)*BASES + j];
        score[6] += dev_pos_specific_scores[(j_-6)*BASES + j]; 
        score[7] += dev_pos_specific_scores[(j_-7)*BASES + j]; 
        score[8] += dev_pos_specific_scores[(j_-8)*BASES + j]; 
        score[9] += dev_pos_specific_scores[(j_-9)*BASES + j]; 
        score[10] += dev_pos_specific_scores[(j_-10)*BASES + j];
        score[11] += dev_pos_specific_scores[(j_-11)*BASES + j];
        score[12] += dev_pos_specific_scores[(j_-12)*BASES + j];
        score[13] += dev_pos_specific_scores[(j_-13)*BASES + j];
        score[14] += dev_pos_specific_scores[(j_-14)*BASES + j];
        score[15] += dev_pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += dev_pos_specific_scores[(j_-16)*BASES + j];
        score[17] += dev_pos_specific_scores[(j_-17)*BASES + j];
        score[18] += dev_pos_specific_scores[(j_-18)*BASES + j];
        score[19] += dev_pos_specific_scores[(j_-19)*BASES + j]; 
        score[20] += dev_pos_specific_scores[(j_-20)*BASES + j];
        score[21] += dev_pos_specific_scores[(j_-21)*BASES + j];
        score[22] += dev_pos_specific_scores[(j_-22)*BASES + j];
        score[23] += dev_pos_specific_scores[(j_-23)*BASES + j];
        score[24] += dev_pos_specific_scores[(j_-24)*BASES + j];
        score[25] += dev_pos_specific_scores[(j_-25)*BASES + j];
        score[26] += dev_pos_specific_scores[(j_-26)*BASES + j];
        score[27] += dev_pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += dev_pos_specific_scores[(j_-28)*BASES + j];
        score[29] += dev_pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += dev_pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += dev_pos_specific_scores[(j_-31)*BASES + j]; */
        j_++;

        ch = ch_[2];
        j = dev_subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += dev_pos_specific_scores[(j_)*BASES + j];
        score[1] += dev_pos_specific_scores[(j_-1)*BASES + j];
        score[2] += dev_pos_specific_scores[(j_-2)*BASES + j];
        score[3] += dev_pos_specific_scores[(j_-3)*BASES + j];
        score[4] += dev_pos_specific_scores[(j_-4)*BASES + j];
        score[5] += dev_pos_specific_scores[(j_-5)*BASES + j];
        score[6] += dev_pos_specific_scores[(j_-6)*BASES + j];
        score[7] += dev_pos_specific_scores[(j_-7)*BASES + j]; 
        score[8] += dev_pos_specific_scores[(j_-8)*BASES + j]; 
        score[9] += dev_pos_specific_scores[(j_-9)*BASES + j]; 
        score[10] += dev_pos_specific_scores[(j_-10)*BASES + j];
        score[11] += dev_pos_specific_scores[(j_-11)*BASES + j];
        score[12] += dev_pos_specific_scores[(j_-12)*BASES + j];
        score[13] += dev_pos_specific_scores[(j_-13)*BASES + j];
        score[14] += dev_pos_specific_scores[(j_-14)*BASES + j];
        score[15] += dev_pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += dev_pos_specific_scores[(j_-16)*BASES + j];
        score[17] += dev_pos_specific_scores[(j_-17)*BASES + j];
        score[18] += dev_pos_specific_scores[(j_-18)*BASES + j];
        score[19] += dev_pos_specific_scores[(j_-19)*BASES + j];  
        score[20] += dev_pos_specific_scores[(j_-20)*BASES + j];
        score[21] += dev_pos_specific_scores[(j_-21)*BASES + j];
        score[22] += dev_pos_specific_scores[(j_-22)*BASES + j];
        score[23] += dev_pos_specific_scores[(j_-23)*BASES + j];
        score[24] += dev_pos_specific_scores[(j_-24)*BASES + j];
        score[25] += dev_pos_specific_scores[(j_-25)*BASES + j];
        score[26] += dev_pos_specific_scores[(j_-26)*BASES + j];
        score[27] += dev_pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += dev_pos_specific_scores[(j_-28)*BASES + j];
        score[29] += dev_pos_specific_scores[(j_-29)*BASES + j];   
        score[30] += dev_pos_specific_scores[(j_-30)*BASES + j];   
        score[31] += dev_pos_specific_scores[(j_-31)*BASES + j]; */
        j_++; 

        ch = ch_[3];
        j = dev_subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += dev_pos_specific_scores[(j_)*BASES + j];
        score[1] += dev_pos_specific_scores[(j_-1)*BASES + j];
        score[2] += dev_pos_specific_scores[(j_-2)*BASES + j];
        score[3] += dev_pos_specific_scores[(j_-3)*BASES + j];
        score[4] += dev_pos_specific_scores[(j_-4)*BASES + j];
        score[5] += dev_pos_specific_scores[(j_-5)*BASES + j];
        score[6] += dev_pos_specific_scores[(j_-6)*BASES + j];  
        score[7] += dev_pos_specific_scores[(j_-7)*BASES + j]; 
        score[8] += dev_pos_specific_scores[(j_-8)*BASES + j]; 
        score[9] += dev_pos_specific_scores[(j_-9)*BASES + j]; 
        score[10] += dev_pos_specific_scores[(j_-10)*BASES + j];
        score[11] += dev_pos_specific_scores[(j_-11)*BASES + j];
        score[12] += dev_pos_specific_scores[(j_-12)*BASES + j];
        score[13] += dev_pos_specific_scores[(j_-13)*BASES + j];
        score[14] += dev_pos_specific_scores[(j_-14)*BASES + j];
        score[15] += dev_pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += dev_pos_specific_scores[(j_-16)*BASES + j];
        score[17] += dev_pos_specific_scores[(j_-17)*BASES + j];
        score[18] += dev_pos_specific_scores[(j_-18)*BASES + j];
        score[19] += dev_pos_specific_scores[(j_-19)*BASES + j];  
        score[20] += dev_pos_specific_scores[(j_-20)*BASES + j];
        score[21] += dev_pos_specific_scores[(j_-21)*BASES + j];
        score[22] += dev_pos_specific_scores[(j_-22)*BASES + j];
        score[23] += dev_pos_specific_scores[(j_-23)*BASES + j];
        score[24] += dev_pos_specific_scores[(j_-24)*BASES + j];
        score[25] += dev_pos_specific_scores[(j_-25)*BASES + j];
        score[26] += dev_pos_specific_scores[(j_-26)*BASES + j];
        score[27] += dev_pos_specific_scores[(j_-27)*BASES + j];  
        score[28] += dev_pos_specific_scores[(j_-28)*BASES + j];
        score[29] += dev_pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += dev_pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += dev_pos_specific_scores[(j_-31)*BASES + j]; */
        j_++;

        ch_ = (char*)&i4.z;
        ch = ch_[0];
        j = dev_subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += dev_pos_specific_scores[(j_)*BASES + j];
        score[1] += dev_pos_specific_scores[(j_-1)*BASES + j];
        score[2] += dev_pos_specific_scores[(j_-2)*BASES + j];
        score[3] += dev_pos_specific_scores[(j_-3)*BASES + j];
        score[4] += dev_pos_specific_scores[(j_-4)*BASES + j];
        score[5] += dev_pos_specific_scores[(j_-5)*BASES + j];
        score[6] += dev_pos_specific_scores[(j_-6)*BASES + j];  
        score[7] += dev_pos_specific_scores[(j_-7)*BASES + j]; 
        score[8] += dev_pos_specific_scores[(j_-8)*BASES + j]; 
        score[9] += dev_pos_specific_scores[(j_-9)*BASES + j]; 
        score[10] += dev_pos_specific_scores[(j_-10)*BASES + j];
        score[11] += dev_pos_specific_scores[(j_-11)*BASES + j];
        score[12] += dev_pos_specific_scores[(j_-12)*BASES + j];
        score[13] += dev_pos_specific_scores[(j_-13)*BASES + j];
        score[14] += dev_pos_specific_scores[(j_-14)*BASES + j];
        score[15] += dev_pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += dev_pos_specific_scores[(j_-16)*BASES + j];
        score[17] += dev_pos_specific_scores[(j_-17)*BASES + j];
        score[18] += dev_pos_specific_scores[(j_-18)*BASES + j];
        score[19] += dev_pos_specific_scores[(j_-19)*BASES + j]; 
        score[20] += dev_pos_specific_scores[(j_-20)*BASES + j];
        score[21] += dev_pos_specific_scores[(j_-21)*BASES + j];
        score[22] += dev_pos_specific_scores[(j_-22)*BASES + j];
        score[23] += dev_pos_specific_scores[(j_-23)*BASES + j];
        score[24] += dev_pos_specific_scores[(j_-24)*BASES + j];
        score[25] += dev_pos_specific_scores[(j_-25)*BASES + j];
        score[26] += dev_pos_specific_scores[(j_-26)*BASES + j];
        score[27] += dev_pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += dev_pos_specific_scores[(j_-28)*BASES + j];
        score[29] += dev_pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += dev_pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += dev_pos_specific_scores[(j_-31)*BASES + j]; */
        j_++;

        ch = ch_[1];
        j = dev_subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += dev_pos_specific_scores[(j_)*BASES + j];
        score[1] += dev_pos_specific_scores[(j_-1)*BASES + j];
        score[2] += dev_pos_specific_scores[(j_-2)*BASES + j];
        score[3] += dev_pos_specific_scores[(j_-3)*BASES + j];
        score[4] += dev_pos_specific_scores[(j_-4)*BASES + j];
        score[5] += dev_pos_specific_scores[(j_-5)*BASES + j];
        score[6] += dev_pos_specific_scores[(j_-6)*BASES + j];
        score[7] += dev_pos_specific_scores[(j_-7)*BASES + j];
        score[8] += dev_pos_specific_scores[(j_-8)*BASES + j];
        score[9] += dev_pos_specific_scores[(j_-9)*BASES + j];
        score[10] += dev_pos_specific_scores[(j_-10)*BASES + j];
        score[11] += dev_pos_specific_scores[(j_-11)*BASES + j];
        score[12] += dev_pos_specific_scores[(j_-12)*BASES + j];
        score[13] += dev_pos_specific_scores[(j_-13)*BASES + j];
        score[14] += dev_pos_specific_scores[(j_-14)*BASES + j];
        score[15] += dev_pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += dev_pos_specific_scores[(j_-16)*BASES + j];
        score[17] += dev_pos_specific_scores[(j_-17)*BASES + j];
        score[18] += dev_pos_specific_scores[(j_-18)*BASES + j];
        score[19] += dev_pos_specific_scores[(j_-19)*BASES + j];
        score[20] += dev_pos_specific_scores[(j_-20)*BASES + j];
        score[21] += dev_pos_specific_scores[(j_-21)*BASES + j];
        score[22] += dev_pos_specific_scores[(j_-22)*BASES + j];
        score[23] += dev_pos_specific_scores[(j_-23)*BASES + j];
        score[24] += dev_pos_specific_scores[(j_-24)*BASES + j];
        score[25] += dev_pos_specific_scores[(j_-25)*BASES + j];
        score[26] += dev_pos_specific_scores[(j_-26)*BASES + j];
        score[27] += dev_pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += dev_pos_specific_scores[(j_-28)*BASES + j];
        score[29] += dev_pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += dev_pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += dev_pos_specific_scores[(j_-31)*BASES + j]; */
        j_++;
 
        ch = ch_[2];
        j = dev_subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += dev_pos_specific_scores[(j_)*BASES + j];
        score[1] += dev_pos_specific_scores[(j_-1)*BASES + j];
        score[2] += dev_pos_specific_scores[(j_-2)*BASES + j];
        score[3] += dev_pos_specific_scores[(j_-3)*BASES + j];
        score[4] += dev_pos_specific_scores[(j_-4)*BASES + j];
        score[5] += dev_pos_specific_scores[(j_-5)*BASES + j];
        score[6] += dev_pos_specific_scores[(j_-6)*BASES + j];
        score[7] += dev_pos_specific_scores[(j_-7)*BASES + j];
        score[8] += dev_pos_specific_scores[(j_-8)*BASES + j];
        score[9] += dev_pos_specific_scores[(j_-9)*BASES + j];
        score[10] += dev_pos_specific_scores[(j_-10)*BASES + j];
        score[11] += dev_pos_specific_scores[(j_-11)*BASES + j];
        score[12] += dev_pos_specific_scores[(j_-12)*BASES + j];
        score[13] += dev_pos_specific_scores[(j_-13)*BASES + j];
        score[14] += dev_pos_specific_scores[(j_-14)*BASES + j];
        score[15] += dev_pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += dev_pos_specific_scores[(j_-16)*BASES + j];
        score[17] += dev_pos_specific_scores[(j_-17)*BASES + j];
        score[18] += dev_pos_specific_scores[(j_-18)*BASES + j];
        score[19] += dev_pos_specific_scores[(j_-19)*BASES + j];
        score[20] += dev_pos_specific_scores[(j_-20)*BASES + j];
        score[21] += dev_pos_specific_scores[(j_-21)*BASES + j];
        score[22] += dev_pos_specific_scores[(j_-22)*BASES + j];
        score[23] += dev_pos_specific_scores[(j_-23)*BASES + j];
        score[24] += dev_pos_specific_scores[(j_-24)*BASES + j];
        score[25] += dev_pos_specific_scores[(j_-25)*BASES + j];
        score[26] += dev_pos_specific_scores[(j_-26)*BASES + j];
        score[27] += dev_pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += dev_pos_specific_scores[(j_-28)*BASES + j];
        score[29] += dev_pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += dev_pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += dev_pos_specific_scores[(j_-31)*BASES + j]; */
        j_++;

        ch = ch_[3];
        j = dev_subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += dev_pos_specific_scores[(j_)*BASES + j];
        score[1] += dev_pos_specific_scores[(j_-1)*BASES + j];
        score[2] += dev_pos_specific_scores[(j_-2)*BASES + j];
        score[3] += dev_pos_specific_scores[(j_-3)*BASES + j];
        score[4] += dev_pos_specific_scores[(j_-4)*BASES + j];
        score[5] += dev_pos_specific_scores[(j_-5)*BASES + j];
        score[6] += dev_pos_specific_scores[(j_-6)*BASES + j];
        score[7] += dev_pos_specific_scores[(j_-7)*BASES + j];
        score[8] += dev_pos_specific_scores[(j_-8)*BASES + j];
        score[9] += dev_pos_specific_scores[(j_-9)*BASES + j];
        score[10] += dev_pos_specific_scores[(j_-10)*BASES + j];
        score[11] += dev_pos_specific_scores[(j_-11)*BASES + j];
        score[12] += dev_pos_specific_scores[(j_-12)*BASES + j];
        score[13] += dev_pos_specific_scores[(j_-13)*BASES + j];
        score[14] += dev_pos_specific_scores[(j_-14)*BASES + j];
        score[15] += dev_pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += dev_pos_specific_scores[(j_-16)*BASES + j];
        score[17] += dev_pos_specific_scores[(j_-17)*BASES + j];
        score[18] += dev_pos_specific_scores[(j_-18)*BASES + j];
        score[19] += dev_pos_specific_scores[(j_-19)*BASES + j];
        score[20] += dev_pos_specific_scores[(j_-20)*BASES + j];
        score[21] += dev_pos_specific_scores[(j_-21)*BASES + j];
        score[22] += dev_pos_specific_scores[(j_-22)*BASES + j];
        score[23] += dev_pos_specific_scores[(j_-23)*BASES + j];
        score[24] += dev_pos_specific_scores[(j_-24)*BASES + j];
        score[25] += dev_pos_specific_scores[(j_-25)*BASES + j];
        score[26] += dev_pos_specific_scores[(j_-26)*BASES + j];
        score[27] += dev_pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += dev_pos_specific_scores[(j_-28)*BASES + j];
        score[29] += dev_pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += dev_pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += dev_pos_specific_scores[(j_-31)*BASES + j]; */
        j_++;

        ch_ = (char*)&i4.w;
        ch = ch_[0];
        j = dev_subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += dev_pos_specific_scores[(j_)*BASES + j];
        score[1] += dev_pos_specific_scores[(j_-1)*BASES + j];
        score[2] += dev_pos_specific_scores[(j_-2)*BASES + j];
        score[3] += dev_pos_specific_scores[(j_-3)*BASES + j];
        score[4] += dev_pos_specific_scores[(j_-4)*BASES + j];
        score[5] += dev_pos_specific_scores[(j_-5)*BASES + j];
        score[6] += dev_pos_specific_scores[(j_-6)*BASES + j];
        score[7] += dev_pos_specific_scores[(j_-7)*BASES + j];
        score[8] += dev_pos_specific_scores[(j_-8)*BASES + j];
        score[9] += dev_pos_specific_scores[(j_-9)*BASES + j];
        score[10] += dev_pos_specific_scores[(j_-10)*BASES + j];
        score[11] += dev_pos_specific_scores[(j_-11)*BASES + j];
        score[12] += dev_pos_specific_scores[(j_-12)*BASES + j];
        score[13] += dev_pos_specific_scores[(j_-13)*BASES + j];
        score[14] += dev_pos_specific_scores[(j_-14)*BASES + j];
        score[15] += dev_pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += dev_pos_specific_scores[(j_-16)*BASES + j];
        score[17] += dev_pos_specific_scores[(j_-17)*BASES + j];
        score[18] += dev_pos_specific_scores[(j_-18)*BASES + j];
        score[19] += dev_pos_specific_scores[(j_-19)*BASES + j];
        score[20] += dev_pos_specific_scores[(j_-20)*BASES + j];
        score[21] += dev_pos_specific_scores[(j_-21)*BASES + j];
        score[22] += dev_pos_specific_scores[(j_-22)*BASES + j];
        score[23] += dev_pos_specific_scores[(j_-23)*BASES + j];
        score[24] += dev_pos_specific_scores[(j_-24)*BASES + j];
        score[25] += dev_pos_specific_scores[(j_-25)*BASES + j];
        score[26] += dev_pos_specific_scores[(j_-26)*BASES + j];
        score[27] += dev_pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += dev_pos_specific_scores[(j_-28)*BASES + j];
        score[29] += dev_pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += dev_pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += dev_pos_specific_scores[(j_-31)*BASES + j]; */
        j_++;

        ch = ch_[1];
        j = dev_subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += dev_pos_specific_scores[(j_)*BASES + j];
        score[1] += dev_pos_specific_scores[(j_-1)*BASES + j];
        score[2] += dev_pos_specific_scores[(j_-2)*BASES + j];
        score[3] += dev_pos_specific_scores[(j_-3)*BASES + j];
        score[4] += dev_pos_specific_scores[(j_-4)*BASES + j];
        score[5] += dev_pos_specific_scores[(j_-5)*BASES + j];
        score[6] += dev_pos_specific_scores[(j_-6)*BASES + j];
        score[7] += dev_pos_specific_scores[(j_-7)*BASES + j];
        score[8] += dev_pos_specific_scores[(j_-8)*BASES + j];
        score[9] += dev_pos_specific_scores[(j_-9)*BASES + j];
        score[10] += dev_pos_specific_scores[(j_-10)*BASES + j];
        score[11] += dev_pos_specific_scores[(j_-11)*BASES + j];
        score[12] += dev_pos_specific_scores[(j_-12)*BASES + j];
        score[13] += dev_pos_specific_scores[(j_-13)*BASES + j];
        score[14] += dev_pos_specific_scores[(j_-14)*BASES + j];
        score[15] += dev_pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += dev_pos_specific_scores[(j_-16)*BASES + j];
        score[17] += dev_pos_specific_scores[(j_-17)*BASES + j];
        score[18] += dev_pos_specific_scores[(j_-18)*BASES + j];
        score[19] += dev_pos_specific_scores[(j_-19)*BASES + j];
        score[20] += dev_pos_specific_scores[(j_-20)*BASES + j];
        score[21] += dev_pos_specific_scores[(j_-21)*BASES + j];
        score[22] += dev_pos_specific_scores[(j_-22)*BASES + j];
        score[23] += dev_pos_specific_scores[(j_-23)*BASES + j];
        score[24] += dev_pos_specific_scores[(j_-24)*BASES + j];
        score[25] += dev_pos_specific_scores[(j_-25)*BASES + j];
        score[26] += dev_pos_specific_scores[(j_-26)*BASES + j];
        score[27] += dev_pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += dev_pos_specific_scores[(j_-28)*BASES + j];
        score[29] += dev_pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += dev_pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += dev_pos_specific_scores[(j_-31)*BASES + j]; */
        j_++;

        ch = ch_[2];
        j = dev_subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += dev_pos_specific_scores[(j_)*BASES + j];
        score[1] += dev_pos_specific_scores[(j_-1)*BASES + j];
        score[2] += dev_pos_specific_scores[(j_-2)*BASES + j];
        score[3] += dev_pos_specific_scores[(j_-3)*BASES + j];
        score[4] += dev_pos_specific_scores[(j_-4)*BASES + j];
        score[5] += dev_pos_specific_scores[(j_-5)*BASES + j];
        score[6] += dev_pos_specific_scores[(j_-6)*BASES + j];
        score[7] += dev_pos_specific_scores[(j_-7)*BASES + j];
        score[8] += dev_pos_specific_scores[(j_-8)*BASES + j];
        score[9] += dev_pos_specific_scores[(j_-9)*BASES + j];
        score[10] += dev_pos_specific_scores[(j_-10)*BASES + j];
        score[11] += dev_pos_specific_scores[(j_-11)*BASES + j];
        score[12] += dev_pos_specific_scores[(j_-12)*BASES + j];
        score[13] += dev_pos_specific_scores[(j_-13)*BASES + j];
        score[14] += dev_pos_specific_scores[(j_-14)*BASES + j];
        score[15] += dev_pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += dev_pos_specific_scores[(j_-16)*BASES + j];
        score[17] += dev_pos_specific_scores[(j_-17)*BASES + j];
        score[18] += dev_pos_specific_scores[(j_-18)*BASES + j];
        score[19] += dev_pos_specific_scores[(j_-19)*BASES + j];
        score[20] += dev_pos_specific_scores[(j_-20)*BASES + j];
        score[21] += dev_pos_specific_scores[(j_-21)*BASES + j];
        score[22] += dev_pos_specific_scores[(j_-22)*BASES + j];
        score[23] += dev_pos_specific_scores[(j_-23)*BASES + j];
        score[24] += dev_pos_specific_scores[(j_-24)*BASES + j];
        score[25] += dev_pos_specific_scores[(j_-25)*BASES + j];
        score[26] += dev_pos_specific_scores[(j_-26)*BASES + j];
        score[27] += dev_pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += dev_pos_specific_scores[(j_-28)*BASES + j];
        score[29] += dev_pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += dev_pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += dev_pos_specific_scores[(j_-31)*BASES + j]; */
        j_++;

        ch = ch_[3];
        j = dev_subst_index[ch - 'A'] + PSS_OFFSET;
        score[0] += dev_pos_specific_scores[(j_)*BASES + j];
        score[1] += dev_pos_specific_scores[(j_-1)*BASES + j];
        score[2] += dev_pos_specific_scores[(j_-2)*BASES + j];
        score[3] += dev_pos_specific_scores[(j_-3)*BASES + j];
        score[4] += dev_pos_specific_scores[(j_-4)*BASES + j];
        score[5] += dev_pos_specific_scores[(j_-5)*BASES + j];
        score[6] += dev_pos_specific_scores[(j_-6)*BASES + j];
        score[7] += dev_pos_specific_scores[(j_-7)*BASES + j];
        score[8] += dev_pos_specific_scores[(j_-8)*BASES + j];
        score[9] += dev_pos_specific_scores[(j_-9)*BASES + j];
        score[10] += dev_pos_specific_scores[(j_-10)*BASES + j];
        score[11] += dev_pos_specific_scores[(j_-11)*BASES + j];
        score[12] += dev_pos_specific_scores[(j_-12)*BASES + j];
        score[13] += dev_pos_specific_scores[(j_-13)*BASES + j];
        score[14] += dev_pos_specific_scores[(j_-14)*BASES + j];
        score[15] += dev_pos_specific_scores[(j_-15)*BASES + j];
/*        score[16] += dev_pos_specific_scores[(j_-16)*BASES + j];
        score[17] += dev_pos_specific_scores[(j_-17)*BASES + j];
        score[18] += dev_pos_specific_scores[(j_-18)*BASES + j];
        score[19] += dev_pos_specific_scores[(j_-19)*BASES + j];
        score[20] += dev_pos_specific_scores[(j_-20)*BASES + j];
        score[21] += dev_pos_specific_scores[(j_-21)*BASES + j];
        score[22] += dev_pos_specific_scores[(j_-22)*BASES + j];
        score[23] += dev_pos_specific_scores[(j_-23)*BASES + j];
        score[24] += dev_pos_specific_scores[(j_-24)*BASES + j];
        score[25] += dev_pos_specific_scores[(j_-25)*BASES + j];
        score[26] += dev_pos_specific_scores[(j_-26)*BASES + j];
        score[27] += dev_pos_specific_scores[(j_-27)*BASES + j]; 
        score[28] += dev_pos_specific_scores[(j_-28)*BASES + j];
        score[29] += dev_pos_specific_scores[(j_-29)*BASES + j]; 
        score[30] += dev_pos_specific_scores[(j_-30)*BASES + j]; 
        score[31] += dev_pos_specific_scores[(j_-31)*BASES + j]; */

        score[0] = score[0] > 0 ? score[0] : 0; score[1] = score[1] > 0 ? score[1] : 0;
        score[2] = score[2] > 0 ? score[2] : 0; score[3] = score[3] > 0 ? score[3] : 0;
        score[4] = score[4] > 0 ? score[4] : 0; score[5] = score[5] > 0 ? score[5] : 0;
        score[6] = score[6] > 0 ? score[6] : 0; score[7] = score[7] > 0 ? score[7] : 0;
        score[8] = score[8] > 0 ? score[8] : 0; score[9] = score[9] > 0 ? score[9] : 0;
        score[10] = score[10] > 0 ? score[10] : 0; score[11] = score[11] > 0 ? score[11] : 0;
        score[12] = score[12] > 0 ? score[12] : 0; score[13] = score[13] > 0 ? score[13] : 0;
        score[14] = score[14] > 0 ? score[14] : 0; score[15] = score[15] > 0 ? score[15] : 0;
/*        score[16] = score[16] > 0 ? score[16] : 0; score[17] = score[17] > 0 ? score[17] : 0;
        score[18] = score[18] > 0 ? score[18] : 0; score[19] = score[19] > 0 ? score[19] : 0; 
        score[20] = score[20] > 0 ? score[20] : 0; score[21] = score[21] > 0 ? score[21] : 0;
        score[22] = score[22] > 0 ? score[22] : 0; score[23] = score[23] > 0 ? score[23] : 0;
        score[24] = score[24] > 0 ? score[24] : 0; score[25] = score[25] > 0 ? score[25] : 0;
        score[26] = score[26] > 0 ? score[26] : 0; score[27] = score[27] > 0 ? score[27] : 0; 
        score[28] = score[28] > 0 ? score[28] : 0; score[29] = score[29] > 0 ? score[29] : 0; 
        score[30] = score[30] > 0 ? score[30] : 0; score[31] = score[31] > 0 ? score[31] : 0; */

        max = score[0] > max ? score[0] : max; max = score[1] > max ? score[1] : max;
        max = score[2] > max ? score[2] : max; max = score[3] > max ? score[3] : max;
        max = score[4] > max ? score[4] : max; max = score[5] > max ? score[5] : max;
        max = score[6] > max ? score[6] : max; max = score[7] > max ? score[7] : max;
        max = score[8] > max ? score[8] : max; max = score[9] > max ? score[9] : max;
        max = score[10] > max ? score[10] : max; max = score[11] > max ? score[11] : max;
        max = score[12] > max ? score[12] : max; max = score[13] > max ? score[13] : max;
        max = score[14] > max ? score[14] : max; max = score[15] > max ? score[15] : max;
/*        max = score[16] > max ? score[16] : max; max = score[17] > max ? score[17] : max;
        max = score[18] > max ? score[18] : max; max = score[19] > max ? score[19] : max; 
        max = score[20] > max ? score[20] : max; max = score[21] > max ? score[21] : max;
        max = score[22] > max ? score[22] : max; max = score[23] > max ? score[23] : max;
        max = score[24] > max ? score[24] : max; max = score[25] > max ? score[25] : max;
        max = score[26] > max ? score[26] : max; max = score[27] > max ? score[27] : max; 
        max = score[28] > max ? score[28] : max; max = score[29] > max ? score[29] : max; 
        max = score[30] > max ? score[30] : max; max = score[31] > max ? score[31] : max; */

      }
    }
    results[id] = max;
  } 
}

