#! /bin/bash

#######################################################################
# ===== PBS OPTIONS =====
# Set the job name
#PBS -N POSTALIGN
# Run in the queue named "viper"
#PBS -q python
# Specify the number of cpus for your job.
#PBS -l nodes=pyt-c1.uncc.edu
### Adjust walltime below (default walltime = 7 days, or 168 hours)
### if you require > 7 days, INCREASE to estimated # hours needed
### if you DON'T require 7 days DECREASE to estimated # hours needed
### (hint: jobs with smaller walltime value tend to run sooner)
#PBS -l walltime=168:00:00
# send PBS output to /dev/null  (we redirect it below)
#PBS -o /dev/null
#PBS -e /dev/null
# ===== END PBS OPTIONS =====
#######################################################################

### Define your input file
#infile="YOUR_INPUT_FILE"

### Define your cmdline arguments
#options="-align"

### Calculate the number of processors allocated to this run.
#NPROCS=`wc -l < $PBS_NODEFILE`

### Get the JOBID w/o the ".m03.uncc.edu"
SHORT_JOBID=`echo $PBS_JOBID |cut -d. -f1`
OUTFILE=$PBS_O_WORKDIR/$PBS_JOBNAME-$SHORT_JOBID.out
ERRFILE=$PBS_O_WORKDIR/$PBS_JOBNAME-$SHORT_JOBID.err

### Redirect standard out and standard error.
exec 1>$OUTFILE 2>$ERRFILE
#exec 2>$ERRFILE

### Load openmpi module
#module load openmpi/1.4.1-ib clustalw-mpi/0.13
module load python
#module load gcc/4.5.3

#######################################################################
# Run the command 
#######################################################################
cd $PBS_O_WORKDIR

#/usr/bin/time -f %e -o time_SRR522163_1.fastq.simulated.div.1_top2_temp_c1_2 ./cudasw -mat blosum45 -query input_reads_SRR522163_1.fastq.simulated.div.1 -db ../../human_genome/ecoli_K12_MG1665.fasta.fixed_512fragments -gapo 26 -gape 1 -topscore_num 2 -min_score 10 -use_single 2 > output_SRR522163_1.fastq.simulated.div.1_top2_temp_c1_2
#/usr/bin/time -f %e -o time_SRR522163_1.fastq.simulated.div.2_top2_temp_c1_2 ./cudasw -mat blosum45 -query input_reads_SRR522163_1.fastq.simulated.div.2 -db ../../human_genome/ecoli_K12_MG1665.fasta.fixed_512fragments -gapo 26 -gape 1 -topscore_num 2 -min_score 10 -use_single 2 > output_SRR522163_1.fastq.simulated.div.2_top2_temp_c1_2

#/usr/bin/time -f %e -o time_frag64_SRR522163_1.fastq.simulated.div.1 ./cudasw -mat blosum45 -query input_reads_SRR522163_1.fastq.simulated.div.1 -db ../../human_genome/ecoli_K12_MG1665.fasta.fixed_64fragments -gapo 26 -gape 1 -topscore_num 2 -min_score 10 -use_single 2 > output_frag64_SRR522163_1.fastq.simulated.div.1
#/usr/bin/time -f %e -o time_frag64_SRR522163_1.fastq.simulated.div.2 ./cudasw -mat blosum45 -query input_reads_SRR522163_1.fastq.simulated.div.2 -db ../../human_genome/ecoli_K12_MG1665.fasta.fixed_64fragments -gapo 26 -gape 1 -topscore_num 2 -min_score 10 -use_single 2 > output_frag64_SRR522163_1.fastq.simulated.div.2

#/usr/bin/time -f %e -o time_frag128_ecoli_500bp_r.5 ./cudasw -mat blosum45 -query input_reads_ecoli_500bp_r.5 -db ../../human_genome/ecoli_K12_MG1665.fasta.fixed_128fragments -gapo 26 -gape 1 -topscore_num 2 -min_score 10 -use_single 2 > output_frag128_ecoli_500bp_r.5

/usr/bin/time -f %e -o time_frag2432_ecoli_2432bp_r.5 ./cudasw -mat blosum45 -query input_reads_ecoli_2432bp_r.5 -db ../../human_genome/ecoli_K12_MG1665.fasta.fixed_2432fragments -gapo 26 -gape 1 -topscore_num 2 -min_score 10 -use_single 2 > output_frag2432_ecoli_2432bp_r.5

