#ifndef COMMON_H
#define COMMON_H

#include "simpleCL.h"

//Define limits
//For look ahead of 16 - shared memory = (len*5 + lookahead*5)*4
//Max query length is 2432. It's the largest multiple of 16 
//below the max length of 2441 given by above formula
#define MAXQLEN 2432
#define FILENAME_LIMIT 1000
#define MAX_CONTIGS 50
#define BUFFERLEN 10000

#define AA 23
#define BASES 5

//Max number of possible letters
#define LETTERS 26

//Set defaults
#define DEFAULT_MATCHCOST 5
#define DEFAULT_MISMATCHCOST -4
#define DEFAULT_GAPOPEN -26
#define DEFAULT_QNAME 1000
//Name of each genome or contig in genome FASTA file
#define DEFAULT_FNAME 1000
//Number of threads per SM
#define DEFAULT_THREADS 256

char* rev(char* str);
  
//__kernel void maxssmap_shared_uint4(unsigned int, cl_uint4*, float*);
/*
__global__ void maxssmap_shared(unsigned int, char*, float*, unsigned int);
__global__ void maxssmap_shared_char4(unsigned int, char4*, float*, unsigned int);
//__global__ void maxssmap_shared_uint4(unsigned int, uint4*, float*, unsigned int);
__global__ void maxssmap_shared_uint2(unsigned int, uint2*, float*, unsigned int);
*/

int DNAGenome ( int argc, char* argv[] );
int DBSearch ( int argc, char* argv[] );

#define OUTPUTTIME 0
#define DEBUG 0
#define NEG_INF -1000000
#define LOOK_AHEAD 16
//#define LOOK_AHEAD 32
//Optimal value of ADDITIONAL_FRAGS = 1 + (query_length/FRAGMENTSIZE)
//If query length varies then select the maximum
#define ADDITIONAL_FRAGS 10
#define PSS_OFFSET LOOK_AHEAD*BASES

#endif

